/* XDCtoolswb_t@C */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOSwb_t@C */
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>
#include <ti/sysbios/hal/Seconds.h>

/* Cwb_t@C */
#include <string.h>
#include <time.h>

/* lbg[NT[rXwb_t@C */
#include <ti/net/sntp/sntp.h>

/* GLCDwb_t@C */
#include "GLCD.h"

/* [U[`}N */
#define CONSOLE(...) do { System_printf(__VA_ARGS__); System_flush(); } while(0)
#define SLEEP(X) Task_sleep((X)*1000/Clock_tickPeriod)

/*
 * UnixԂ[J^Cɕϊ
 */
struct tm *localtime(const time_t *_timer)
{
    static struct tm t_st;
    char mdays[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
    time_t timer = *_timer;

#if defined(__ti__)

    // TI-RTOStime֐1900NɂbԂ̂ŁA
    // UNIXԁi1970NɂbjɕϊB
    timer -= 2208988800;
#endif

    // iUTC+09:00j
    timer += 9 * 60 * 60;

    // ̎Zo
    t_st.tm_hour = (timer / (60 * 60)) % 24; // uv̎擾
    t_st.tm_min = (timer / 60) % 60; // uv̎擾
    t_st.tm_sec = timer % 60; // ubv̎擾

    // 1970N11̓̎Zo
    uint32_t days = timer / (24 * 60 * 60);

    // j̎Zo
    t_st.tm_wday = (days + 4) % 7;

    // 4NPʂł̔N̎Zo
    uint32_t y4 = days / (365 * 3 + 366);

    // 4NPʓł̓̎Zo
    uint32_t y4days = days % (365 * 3 + 366);

    // NƁAN̏߂̓̎Zo
    t_st.tm_year = 70 + 4 * y4;
    if (y4days < 365)
    {
        t_st.tm_yday = y4days;
    }
    else if (y4days < 365 * 2)
    {
        t_st.tm_year += 1;
        t_st.tm_yday = y4days - 365;
    }
    else if (y4days < 365 * 2 + 366)
    {
        t_st.tm_year += 2;
        t_st.tm_yday = y4days - 365 * 2;

        // 21₷i邤Nj
        mdays[1]++;
    }
    else
    {
        t_st.tm_year += 3;
        t_st.tm_yday = y4days - (365 * 2 + 366);
    }

    // ƁȀ߂̓̎Zo
    t_st.tm_mday = t_st.tm_yday;

    // ̎Zo
    t_st.tm_mon = 0;
    while (t_st.tm_mon < 11)
    {
        if (t_st.tm_mday < mdays[t_st.tm_mon])
            break;
        t_st.tm_mday -= mdays[t_st.tm_mon];
        t_st.tm_mon++;
    }

    // ̏߂̓̓tɊZ
    t_st.tm_mday++;

    // ĎԂ̎Zo
    t_st.tm_isdst = 0; // {Ԃɂ͖
    return &t_st;
}
/*
 * SNTP^XN
 */
Void task_SNTP(UArg arg0, UArg arg1)
{
    int i; // ėpJE^
    struct sockaddr_in sntpAddr;
    char *hostname = "ntp.nict.jp";
    struct addrinfo hints, *res;
    uint32_t s_addr;
    int error;

    // 擾zXg̊̐ݒ
    memset(&hints, 0, sizeof(hints));
    hints.ai_socktype = SOCK_DGRAM;
    hints.ai_family = AF_INET;

    // zXg̏擾
    CONSOLE("SNTP host: %s\n", hostname);
    error = getaddrinfo(hostname, NULL, &hints, &res);
    if (error != 0)
    {
        CONSOLE("getaddrinfo: %d\n", error);
        GLCD_str(3, 0, "Cannot get IP addr...");
        return;
    }

    // IPAhXϐs_addrɑ
    s_addr = ((struct sockaddr_in*) (res->ai_addr))->sin_addr.s_addr;
    CONSOLE("ip address: %d.%d.%d.%d\n", s_addr & 0xff, (s_addr >> 8) & 0xff,
            (s_addr >> 16) & 0xff, (s_addr >> 24) & 0xff);

    // zXg̃
    freeaddrinfo(res);

    // GLCDɕ\
    GLCD_str(3, 0, "Date:");

    // SNTPT[oւ̐ڑ̐ݒ
    sntpAddr.sin_family = AF_INET;
    sntpAddr.sin_addr.s_addr = s_addr;
    sntpAddr.sin_port = htons(123);

    // SNTPW[Nij
    SNTP_start(Seconds_get, Seconds_set, NULL, (struct sockaddr*) &sntpAddr, 1, 0);
    while (1)
    {
        // 0.5b1JԂ
        for (i = 0; i < 2 * 60 * 60 * 24; i++)
        {
            // 0.5b҂
            SLEEP(500);

            // [JԂ̎擾
            time_t timer = time(NULL);
            struct tm *t_st = localtime(&timer);

            // [J𕶎ɕϊ
            char tstr[20];
            tstr[0] = (t_st->tm_year + 1900) / 1000 + 0x30;
            tstr[1] = ((t_st->tm_year + 1900) / 100) % 10 + 0x30;
            tstr[2] = ((t_st->tm_year + 1900) / 10) % 10 + 0x30;
            tstr[3] = (t_st->tm_year + 1900) % 10 + 0x30;
            tstr[4] = '/';
            tstr[5] = (t_st->tm_mon + 1) / 10 + 0x30;
            tstr[6] = (t_st->tm_mon + 1) % 10 + 0x30;
            tstr[7] = '/';
            tstr[8] = (t_st->tm_mday) / 10 + 0x30;
            tstr[9] = (t_st->tm_mday) % 10 + 0x30;
            tstr[10] = ' ';
            tstr[11] = (t_st->tm_hour) / 10 + 0x30;
            tstr[12] = (t_st->tm_hour) % 10 + 0x30;
            tstr[13] = ':';
            tstr[14] = (t_st->tm_min) / 10 + 0x30;
            tstr[15] = (t_st->tm_min) % 10 + 0x30;
            tstr[16] = ':';
            tstr[17] = (t_st->tm_sec) / 10 + 0x30;
            tstr[18] = (t_st->tm_sec) % 10 + 0x30;
            tstr[19] = '\0';

            // GLCDɕ`
            GLCD_str(4, 2, tstr);
        }

        // SNTPT[oƎ𓯊i11j
        SNTP_forceTimeSync();
    }
}
